<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (v.1.x)
 *   Plugin Fast start (v.0.2)
 *   Copyright © 2013 Bishovec Nikolay
 *
   --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
   ---------------------------------------------------------
 */

class PluginFaststart_HookFaststart extends Hook
{

    public function RegisterHook()
    {
        $this->AddHook('template_registration_begin', 'RegistrationBegin');
        $this->AddHook('template_form_registration_begin', 'FormRegistrationBegin');

        $this->AddHook('registration_validate_before', 'ValidateBefore');
        $this->AddHook('registration_after', 'ValidateAfter');

        $this->AddHook('template_form_settings_profile_begin', 'SettingsProfileBegin');
        $this->AddHook('settings_profile_save_after', 'SettingsSaveAfter');
        $this->AddHook('settings_profile_save_before', 'SettingsSaveBefore');

        $this->AddHook('template_copyright', 'Copyright', __CLASS__);
    }

    public function RegistrationBegin($aVar)
    {
        $this->Viewer_Assign('isPopup', $aVar['isPopup']);
        return $this->Viewer_Fetch(Plugin::GetTemplatePath('faststart') . '/registration.begin.tpl');
    }

    public function FormRegistrationBegin($aVar)
    {

        $this->Viewer_Assign('isPopup', $aVar['isPopup']);
        return $this->Viewer_Fetch(Plugin::GetTemplatePath('faststart') . '/registration.begin.form.tpl');
    }

    public function SettingsProfileBegin()
    {
        if (Config::Get('plugin.faststart.create_login') == 'mail') {
            return;
        }

        return $this->Viewer_Fetch(Plugin::GetTemplatePath('faststart') . '/settings.profile.tpl');
    }

    public function SettingsSaveBefore($aVar)
    {
        if (Config::Get('plugin.faststart.create_login') == 'mail') {
            return;
        }

        if (getRequest('user_login', null, 'post') and getRequest('user_login', null, 'post') != $aVar['oUser']->getLogin()) {
            if (!$this->User_CheckLogin(getRequest('user_login', null, 'post'))) {
                $aVar['bError'] = true;
                $this->Message_AddErrorSingle($this->Lang_Get('plugin.faststart.login_error'));
            }
            if ($oUserExist = $this->User_GetUserByLogin(getRequest('user_login', null, 'post')) and $oUserExist->getId() != $aVar['oUser']->getId()) {
                $aVar['bError'] = true;
                $this->Message_AddErrorSingle($this->Lang_Get('plugin.faststart.login_error_used'));
            }
        }
        return $aVar;
    }

    public function SettingsSaveAfter($aVar)
    {
        if (Config::Get('plugin.faststart.create_login') == 'mail') {
            return;
        }

        if (getRequest('user_login', null, 'post') and getRequest('user_login', null, 'post') != $aVar['oUser']->getLogin()) {
            $oUser = $aVar['oUser'];
            $oUser->setLogin(getRequest('user_login', null, 'post'));
            $oUser->setProfileDate(date("Y-m-d H:i:s", time() + 1));
            $this->User_UpdateUserLogin($oUser);
            $oBlog = $this->Blog_GetPersonalBlogByUserId($oUser->getId());
            $oBlog->setTitle($this->Lang_Get('blogs_personal_title') . ' ' . $oUser->getLogin());
            $this->Blog_UpdateBlog($oBlog);
        }
    }

    public function ValidateAfter($aVar)
    {
        if (getRequest('fs_start_registration') == 'old') {
            return;
        }

        if (Config::Get('plugin.faststart.create_login') == 'mail') {
            return;
        }

        $oUser = $aVar['oUser'];
        if (Config::Get('plugin.faststart.create_login') != 'mail') {
            if (Config::Get('plugin.faststart.id_count_zeros') > 0) {
                $iId = str_pad((string)$oUser->getId(), Config::Get('plugin.faststart.id_count_zeros'), '0', STR_PAD_LEFT);
            } else {
                $iId = $oUser->getId();
            }
            $oUser->setLogin(Config::Get('plugin.faststart.id_prefix') . $iId);
            $oUser->setProfileDate(date("Y-m-d H:i:s", time() + 1));
            $this->User_UpdateUserLogin($oUser);
        }
    }

    public function ValidateBefore($aVar)
    {

        if (getRequest('fs_start_registration') == 'old') {
            return;
        }
        $oUser = $aVar['oUser'];

        if (Config::Get('plugin.faststart.create_login') == 'mail') {
            $aLogin = explode('@', getRequest('mail'));
            if (!getRequest('login')) {
                $_REQUEST['login'] = $aLogin['0'];
            }
        } else {
            $_REQUEST['login'] = Config::Get('plugin.faststart.id_prefix') . time();
        }

        $oUser->setLogin(getRequest('login'));
        $this->Viewer_AssignAjax('new_login', $oUser->getLogin());

        $sPassword = func_generator(6);
        $_REQUEST['password'] = $sPassword;
        $oUser->setPassword($sPassword);
        $oUser->setPasswordConfirm($sPassword);

        $sCaptcha = 0;
        $_SESSION['captcha_keystring'] = $sCaptcha;
        $oUser->setCaptcha($sCaptcha);

        return array('oUser' => $oUser);
    }

    public function Copyright()
    {
        if (Router::GetAction() != 'profile' and Router::GetAction() != 'index' and Router::GetAction() != 'blog') {
            return false;
        }
        return '<a href="http://catalog.netlanc.net" target="_blank">Плагин "Fast start" сделан в catalog.netlanc.net</a><br />';
    }
}

?>
